package com.ffm.test.hornetq;

import java.util.HashMap;
import java.util.Map;


import org.hornetq.api.core.HornetQException;
import org.hornetq.api.core.TransportConfiguration;
import org.hornetq.api.core.client.ClientConsumer;
import org.hornetq.api.core.client.ClientMessage;

import org.hornetq.api.core.client.ClientProducer;
import org.hornetq.api.core.client.ClientSession;
import org.hornetq.api.core.client.ClientSessionFactory;
import org.hornetq.api.core.client.HornetQClient;
import org.hornetq.api.core.client.MessageHandler;

import org.hornetq.core.config.Configuration;
import org.hornetq.core.config.impl.ConfigurationImpl;


import org.hornetq.integration.transports.netty.NettyConnectorFactory;



public class Callee {

	/**
	 * @param args
	 */
	public static void main(String[] args) throws Exception {
		
		new Callee().startService();
	}
	
	public void startService() throws Exception {
		
        Configuration configuration = new ConfigurationImpl();
        configuration.setPersistenceEnabled(false);
        configuration.setSecurityEnabled(false);

        //add network config
        Map<String, Object> params = new HashMap<String, Object>();
        params.put("host", "localhost");
        params.put("port", 5447);
        
        //params.put("host", "research-app01.360t.com");
        //params.put("port", 5446);

        TransportConfiguration transportConfiguration = 
            new TransportConfiguration(NettyConnectorFactory.class.getName(), params);                

        
        ClientSessionFactory factory =  HornetQClient.createClientSessionFactory(
        		transportConfiguration);

        ClientSession session = factory.createSession();

        session.createTemporaryQueue(Server.serviceName, Server.serviceName);        
        
        session.start();

        ClientConsumer consumer = session.createConsumer(Server.serviceName);
        
        consumer.setMessageHandler(new QueueHandler(session));

        Thread.sleep(10000000);
	}

	class QueueHandler implements MessageHandler {

		ClientSession session;
		public QueueHandler(ClientSession aSession) {
			session = aSession;
		}
		
		public void onMessage(ClientMessage message) {
			String msg = message.getStringProperty("generalmessage");			
			String returnAddress = message.getStringProperty("returnAddress");
			System.out.println("received message "+msg);
			
			try {
				ClientProducer returnProducer = session.createProducer(returnAddress);
		        ClientMessage returnMessage = session.createMessage(false);

		        returnMessage.putStringProperty("return", msg+"_returned");
		        
		        returnProducer.send(returnMessage);
				
			} catch (HornetQException e) {
				e.printStackTrace();
			}
		}


		
	}
	
}
